 function _dynRotary ($parent, $idl, $class) { var e = document.createElement ("canvas"); if ($idl) e.setAttribute ("_idl", $idl); _addClass (e, $class); _ensureObject ($parent).appendChild (e); return e; } function class_Rotary (canvas, min, max, linear) { if (linear === undefined) linear = false; var image; var width = 0; var height = 0; var snapped = false; var naturalWidth = 0; var naturalHeight = 0; var startX = 0; var startY = 0; var orientation = 0; var frames = 0; var THIS =  { _value: 0, set value (v) { this._value = v; redraw(); }, get value () { return this._value; }, }; function init () { canvas = _ensureObject (canvas); _assert (canvas, "class_Rotary: invalid canvas id or object!"); var style = window.getComputedStyle (canvas); width = style.getPropertyValue ("width").replace ("px", ""); height = style.getPropertyValue ("height").replace ("px", ""); canvas.setAttribute ("width", width); canvas.setAttribute ("height", height); if (g_HasPointerLock) { canvas.addEventListener ("pointerdown", function () { onPointerDown (event); }); canvas.addEventListener ("pointerup", function () { onPointerUp (event); }); } else { canvas.addEventListener ("mousedown", function () { onMouseDown (event); }); canvas.addEventListener ("mouseup", function () { onMouseUp (event); }); } canvas._control = THIS; var src = style.getPropertyValue ("background-image").replace ("url(\"", "").replace ("\")", ""); src = src.replace ('url(', ""); src = src.replace (')', ""); if (src == "none") redraw (); else { canvas.style.backgroundImage = "none"; image = new Image(); image.src = src; image.addEventListener("load", function () { onImageLoaded (); }); image.addEventListener('error', function() { alert('class_Rotary: Error loading image! (Path not found?)') }); } }; function onImageLoaded () { naturalWidth = image.naturalWidth; naturalHeight = image.naturalHeight; orientation = naturalWidth > naturalHeight? SCX_HORZ : SCX_VERT; frames = orientation == SCX_HORZ? (naturalWidth / width) : (naturalHeight / height); redraw (); }; function onPointerDown (event) { snapped = false; startX = event.clientX; startY = event.clientY; onMouseSetValue (event); canvas.addEventListener("mousemove", onMouseMove, false); canvas.setPointerCapture (event.pointerId); }; function onPointerUp (event) { canvas.removeEventListener("mousemove", onMouseMove, false); canvas.releasePointerCapture(event.pointerId); }; function onMouseDown (event) { snapped = false; startX = event.clientX; startY = event.clientY; onMouseSetValue (event); canvas.addEventListener("mousemove", onMouseMove, false); canvas.setCapture(); }; function onMouseUp (event) { canvas.removeEventListener("mousemove", onMouseMove, false); canvas.releaseCapture(); }; function onMouseMove (event) { onMouseSetValue (event); }; function onMouseSetValue (event) { var v = 0; if (linear) v = THIS.value + (startY - event.clientY) / width * 4; else { var space = 45/360 * Math.PI; var rc = canvas.getBoundingClientRect(); var dx = event.clientX - (Math.round (rc.left) + width/2); var dy = event.clientY - (Math.round (rc.top) + height/2); if (dx*dx + dy*dy > 25.0) { var angle = Math.atan2 (dx, -dy) + Math.PI-space; var portion = angle / (2 * (Math.PI-space)); if (snapped && (portion < 0.5 && THIS.value >= max ||  portion > 0.5 && THIS.value <= min)) return; v = portion * (max - min); } } if (v > max) v = max; else if (v < min) v = min; if (v == min || v == max) snapped = true; THIS.value = Math.round (v); var e = document.createEvent("Event"); e.initEvent ("change", true, true); canvas.dispatchEvent(e); }; function redraw () { var context = canvas.getContext("2d"); context.clearRect (0, 0, width, height); if (image) { var frame = Math.round ((THIS.value * (frames-1))/(max - min)); if (orientation == SCX_VERT) context.drawImage  (image, 0, frame * height, naturalWidth, naturalHeight / frames, 0, 0, width, height); else if (orientation == SCX_HORZ) context.drawImage  (image, frame * width, 0, naturalWidth / frames, naturalHeight, 0, 0, width, height); else _assert (0, "class_Rotary: invalid orientation!"); } else { var style = window.getComputedStyle (canvas); var color = style.getPropertyValue("color"); var font = style.getPropertyValue("font-size") + " " + style.getPropertyValue("font-family"); var centerx = width/2; var centery = height/2; var arcweight = Math.max (2, centerx/7); var radius = centerx - 1.5*arcweight; var arcbegin = 0.75*Math.PI; var arcend = 0.25*Math.PI; var arcval = (THIS.value/(max-min))*(1.5*Math.PI); context.beginPath(); context.arc (centerx, centery, radius, arcbegin, arcend); context.lineWidth = arcweight; context.globalAlpha = 0.15; context.strokeStyle = color; context.stroke (); context.beginPath(); context.arc (centerx, centery, radius, arcbegin, arcbegin + arcval); context.lineWidth = arcweight; context.globalAlpha = 0.6; context.strokeStyle = color; context.stroke (); var rad = arcval + 0.5*Math.PI; context.translate (centerx, centery); context.rotate (rad); var outer = radius - 2*arcweight; context.beginPath(); context.moveTo (outer, outer); context.lineTo (outer - 1*arcweight, outer - 2*arcweight); context.lineTo (outer - 2*arcweight, outer - 1*arcweight); context.globalAlpha = 1.0; context.fillStyle = color; context.fill(); context.rotate (rad*(-1)); context.translate(centerx*(-1), centery*(-1)); if (true) { context.textAlign = "center"; context.textBaseline = 'middle'; context.font = font; context.globalAlpha = 0.8; context.fillStyle = color; context.fillText (THIS.value, centerx, centery); } } }; init (); return THIS; } 